import time, threading, pandas, numpy

from api.kraken import Kraken
from api.fake import Fake


if __name__ == "__main__":
    current_state = "Unknown"
    previous_state = "Unknown"

    currency_buy = "XXBT"
    currency_sell = "ZUSD"
    currency_pair = "XXBTZUSD"

    k = Kraken()
    print("1")

    time.sleep(1)

    k.get_ohlc_prices(currency_pair)
    print("3")

    time.sleep(1)

    while True:
        k.get_current_price(currency_pair)
        k.calculate_ema()

        k.get_fee()

        # If we have crypto, check for sell behaviour, if we have fiat, check for buy behavior, otherwise, get really confused
        if k.balances["vol"][currency_buy] > 10**-5:
            if current_state == "Buying":
                previous_state = "Buying"
            
            current_state = "Selling"

            # Sell shit
            # If the previous state is known, and the short term EMA (accounting for the fee) is less than the long term EMA,
            # and there is more than a 0.1% difference between short and long term EMA (accounting for the fee), sell
            if previous_state != "Unknown" and k.short_ema.tail(1)[0][0] * (1-self.fee/100) < k.long_ema.tail(1)[0][0] and k.long_ema.tail(1)[0][0]/(k.short_ema.tail(1)[0][0] * (1-self.fee/100)) - 1  > 0.001:
                if k.short_ema.tail(1)[0][0]
                print("Selling shit")
                k.sell_order(currency_pair, currency_buy, currency_sell, k.balances["vol"][currency_buy])
                print(k.balances)

        elif k.balances["vol"][currency_sell] > 10**-2:
            if current_state == "Selling":
                previous_state = "Selling"
            
            current_state = "Buying"
            
            # Buy shit
            # If the previous state is known, and the short term EMA (accounting for the fee) is greater than the long term EMA,
            # and there is more than a 0.1% difference between short and long term EMA (accounting for the fee), buy
            if previous_state != "Unknown" and k.short_ema.tail(1)[0][0] * (self.fee/100+1) > k.long_ema.tail(1)[0][0] and (k.short_ema.tail(1)[0][0] * (self.fee/100+1))/k.long_ema.tail(1)[0][0] - 1 > 0.001:
                print("Buying shit")
                k.buy_order(currency_pair, currency_buy, currency_sell, k.balances["vol"][currency_sell] * 0.95 * (1/k.prices.tail(1)[0][0]))
                print(k.balances)

        else:
            raise Exception("There is no currency in this account.")

        time.sleep(3)
